#!/bin/sh

GNUGO=../interface/gnugo

passes=0
failures=0
unexpected=0

gtpfile=$1
expectfile=$2
options=$3   # May be omitted
options2=$4  # May be omitted  FIXME: Do multiple options nicer.
IFS="
"

for i in `$GNUGO --quiet $options $options2 --mode gtp <$gtpfile | \
          egrep '^[=?][0-9]+' | cut -c 2-`
do
  number=`echo $i | cut -d ' ' -f 1`
  result=`echo $i | cut -d ' ' -f 2-`
  correct=`grep "^$number " $expectfile | cut -d ' ' -f 2- | sed 's/[]*[]//g'`
  expect=`grep "^$number " $expectfile | awk '/\*$/ {print "fail"}'`
  ignore=`grep "^$number " $expectfile | awk '/&$/ {print "ignore"}'`
  negate=`echo $correct | awk "match(\\$0,\"^!\") {print \"negate\"}"`
  new_correct=$correct
  if [ "$negate" = "negate" ]
  then
    new_correct=`echo $correct | cut -c 2-`
  fi

  compare=`echo $result | awk "match(\\$0,\"^$new_correct\$\") {print \"match\"}"`

  if [ "$negate" = "negate" ]
  then
    compare=`echo $compare | awk "!match(\\$0,\"match\") {print \"match\"}"`
  fi

  if [ "$ignore" = "ignore" ]
  then
    echo $number $result
  elif [ "$compare" != "match" ]
  then
    failures=`expr $failures + 1`
    if [ "$expect" != "fail" ]
    then
      unexpected=`expr $unexpected + 1`
      echo $number FAILED: Correct \"$correct\", got \"$result\"
    else
      echo $number failed: Correct \"$correct\", got \"$result\"
    fi
  else
    passes=`expr $passes + 1`
    if [ "$expect" = "fail" ]
    then
      unexpected=`expr $unexpected + 1`
      echo $number PASSED!
    else
      echo $number passed
    fi
  fi
done

total=`expr $passes + $failures`

if [ "$unexpected" != "1" ]
then
    echo Summary: $passes/$total passes, $unexpected unexpected results
else
    echo Summary: $passes/$total passes, $unexpected unexpected result
fi
