#invoke with gnugo --mode gtp < reading.gtp | awk -f regress.awk res=reading.res

# store results of gnugo in array gtpout

# store test numbers in array test to be able
# to retrieve test results in same order as in gtp file

BEGIN {
	ntest = 0
}

/^=[0-9]+ /{
      sub(/^=/, "")
      num = $1
      sub(/^[0-9]+ */, "")
      gtpout[num] = $0
      test[ntest] = num
      ntest++;
}

END {

# store contents of res file in array expect

  while (getline < res) {
    num = $1
    sub(/^[0-9]+ */,"")
    expect[num] = $0
  }

# check results of gnugo --mode gtp

  for (i=0;i<ntest;i++) {

    num = test[i]
    correct = expect[num]
    sub(/^\[/,"^",correct)
    sub(/\][&*]*$/,"$",correct)

    ignore = 0
    fail = 0
    negate = 0
    if (match(expect[num],/&$/)) {
	ignore = 1
    }
    if (match(expect[num],/\*/)) {
	fail = 1
    }
    if (match(correct,/^\^!/)) {
	negate = 1
	sub(/^\^!/, "^", correct)
    }

    if (!ignore) {
      match_result = match(gtpout[num],correct)
      if (negate)
	match_result = !match_result
      if (match_result) {
	if (fail) {
	  print num " unexpected PASS!"
	}
      } else {
	if (!fail) {
	  sub(/^\^/, "", correct)
	  sub(/\$$/, "", correct)
	  if (negate)
	    sub(/^/, "!", correct)
	  print num " unexpected FAIL: Correct " correct ", got " gtpout[num]
	}
      }
    }
  }
}
